#!/usr/bin/perl
#
# Cacti TempTrax query script, 03.05.06 Paul Venezia (pvenezia@jpj.net)
#
#	It's pretty ugly, but the non-standard SNMP support in these 
#	devices makes this necessary. Sigh.
#
#

use strict;
use Data::Dumper;


my ($probecount);
my %tempdata;

my $probe = $ARGV[0];
my $comm = 'public';
#my $comm = $ARGV[1];
my $func = $ARGV[2];

open(WALK, "/usr/bin/snmpwalk -c $comm -v1 -On $probe .iso |");

foreach my $snmpret (<WALK>) {
	chomp($snmpret);
	if ($snmpret =~ /\.1\.3\.6\.1\.4\.1\.16174\.1\.1\.1\.1\.2\.0\s=\sSTRING:\s\"(.+)\"/) {
		my $pcount = $1;
		$pcount =~ s/^E//;
		$probecount = $pcount;
	}
		
	if ($snmpret =~ /\.1\.3\.6\.1\.4\.1\.16174\.1\.1\.1\.3\.(\d)\.(\d)\.0\s=\s(\w+):\s(.*)/) {
		if ($1 <= $probecount) {
			$tempdata{$1}{probe} = $1;
			$tempdata{$1}{name} = $4 if $2 == 1;
			$tempdata{$1}{name} =~ s/\"//;
			$tempdata{$1}{temp} = $4 if $3 eq 'INTEGER';
		}
	}
}

#print Dumper %tempdata;

	if ($func eq "index") {
		foreach my $pindex ( sort keys %tempdata ) {
			print "$pindex:$pindex\n";
		}

	} elsif ($func eq "get") {
		foreach my $pindex ( sort keys %tempdata ) {
			print "$tempdata{$pindex}{$ARGV[3]}" if $ARGV[4] == $pindex;
		}
	} elsif ($func eq "query") {
		foreach my $pindex ( sort keys %tempdata ) {
			print "$pindex:$tempdata{$pindex}{$ARGV[3]}\n";
		}
	}
        
#print Dumper %licstatus;        
